import { PreviewGenerator } from './preview';
import { SchemaValidator, SchemaOptions, SchemaField } from './types';
export declare abstract class BaseGenerator {
    protected _name?: string;
    protected _title?: string;
    constructor(name?: string, title?: string);
    title(title: string): this;
    name(name: string): this;
}
export declare abstract class StandardGenerator extends BaseGenerator {
    protected _type: string;
    protected _description?: string;
    protected _readOnly: boolean;
    protected _hidden: boolean;
    protected _options: SchemaOptions;
    protected _validation?: SchemaValidator;
    protected _preview?: PreviewGenerator;
    protected _fieldset?: string;
    constructor(type: string, name?: string, title?: string);
    description(description: string): this;
    readOnly(readOnly?: boolean): this;
    hidden(hidden?: boolean): this;
    validation(fn: SchemaValidator): this;
    preview(preview: PreviewGenerator): this;
    fieldset(fieldset: string): this;
    options(options: SchemaOptions): this;
    option(property: string, value: any): this;
    protected extendProperties(field: SchemaField): void;
    generate(): SchemaField;
}
export declare abstract class GeneratorWithFields extends StandardGenerator {
    protected _fields: StandardGenerator[];
    protected _predefinedFields: Record<string, any>;
    constructor(predefinedFields: Record<string, any> | undefined, type: string, name?: string, title?: string);
    field(field: string | StandardGenerator): this;
    fields(fields: Array<string | StandardGenerator>): this;
    protected extendProperties(field: SchemaField): void;
    generate(): SchemaField;
}
