import { StandardGenerator, GeneratorWithFields } from '../base';
import { PredefinedField, SchemaBlockList, SchemaBlockMarks, SchemaBlockStyle, SchemaField } from '../types';
export declare class BlockFieldGenerator extends StandardGenerator {
    protected _styles: SchemaBlockStyle[];
    protected _lists: SchemaBlockList[];
    protected _marks: SchemaBlockMarks;
    constructor(styles: SchemaBlockStyle[], lists: SchemaBlockList[], marks: SchemaBlockMarks);
    protected extendProperties(field: SchemaField & {
        styles: SchemaBlockStyle[];
        lists: SchemaBlockList[];
        marks: SchemaBlockMarks;
    }): void;
    generate(): SchemaField & {
        marks?: SchemaBlockMarks | undefined;
    };
}
export declare class BlocksFieldGenerator extends GeneratorWithFields {
    protected _styles: SchemaBlockStyle[];
    protected _lists: SchemaBlockList[];
    protected _marks: SchemaBlockMarks;
    constructor(predefinedFields: PredefinedField | undefined, name?: string, title?: string);
    styles(styles: SchemaBlockStyle[]): this;
    lists(lists: SchemaBlockList[]): this;
    marks(marks: SchemaBlockMarks): this;
    fields(): this;
    of(fields: Array<string | StandardGenerator>): this;
    protected extendProperties(field: SchemaField): void;
}
