import { OrderingGenerator } from '../ordering';
import { GeneratorWithFields } from '../base';
import { PredefinedField, SchemaField, SchemaIcon } from '../types';
import { FieldSetGenerator } from './fieldset';
export declare class DocumentGenerator extends GeneratorWithFields {
    protected _liveEdit?: boolean;
    protected _orderings: OrderingGenerator[];
    protected _fieldsets: FieldSetGenerator[];
    protected _icon?: SchemaIcon;
    constructor(predefinedFields: PredefinedField | undefined, name: string, title?: string);
    liveEdit(liveEdit?: boolean): this;
    icon(icon: SchemaIcon): this;
    orderings(orderings: OrderingGenerator[]): this;
    fieldsets(sets: FieldSetGenerator[]): this;
    protected extendProperties(field: SchemaField & {
        orderings?: OrderingGenerator[];
        icon?: any;
        liveEdit?: boolean;
        fieldsets: FieldSetGenerator[];
    }): void;
    generate(): SchemaField & {
        fieldsets: FieldSetGenerator[];
        orderings: OrderingGenerator[];
    };
}
