import { ArrayFieldGenerator, BlocksFieldGenerator, BooleanFieldGenerator, DateFieldGenerator, DatetimeFieldGenerator, DocumentGenerator, FieldGenerator, FieldSetGenerator, FileFieldGenerator, GeopointFieldGenerator, ImageFieldGenerator, NumberFieldGenerator, ObjectFieldGenerator, ReferenceFieldGenerator, SlugFieldGenerator, StringFieldGenerator, TextFieldGenerator, UrlFieldGenerator } from './fields';
import { OrderingGenerator } from './ordering';
import { PreviewGenerator } from './preview';
import { PredefinedField } from './types';
export declare class SchemaBuilder {
    private _predefinedFields;
    constructor(predefinedFields?: Record<string, Record<string, any>>);
    define(key: string, field: PredefinedField): void;
    f: (type: string, name?: string | undefined, title?: string | undefined) => FieldGenerator;
    field(type: string, name?: string, title?: string): FieldGenerator;
    arr: (name?: string | undefined, title?: string | undefined) => ArrayFieldGenerator;
    array(name?: string, title?: string): ArrayFieldGenerator;
    blocks(name?: string, title?: string): BlocksFieldGenerator;
    bool: (name?: string | undefined, title?: string | undefined) => BooleanFieldGenerator;
    boolean(name?: string, title?: string): BooleanFieldGenerator;
    date(name?: string, title?: string): DateFieldGenerator;
    dt: (name?: string | undefined, title?: string | undefined) => DatetimeFieldGenerator;
    datetime(name?: string, title?: string): DatetimeFieldGenerator;
    doc: (name: string, title?: string | undefined) => DocumentGenerator;
    document(name: string, title?: string): DocumentGenerator;
    fset: (name: string, title?: string | undefined) => FieldSetGenerator;
    fieldset(name: string, title?: string): FieldSetGenerator;
    file(name?: string, title?: string): FileFieldGenerator;
    geo: (name?: string | undefined, title?: string | undefined) => GeopointFieldGenerator;
    geopoint(name?: string, title?: string): GeopointFieldGenerator;
    img: (name?: string | undefined, title?: string | undefined) => ImageFieldGenerator;
    image(name?: string, title?: string): ImageFieldGenerator;
    num: (name?: string | undefined, title?: string | undefined) => NumberFieldGenerator;
    number(name?: string, title?: string): NumberFieldGenerator;
    obj: (name?: string | undefined, title?: string | undefined) => ObjectFieldGenerator;
    object(name?: string, title?: string): ObjectFieldGenerator;
    ref: (name?: string | undefined, title?: string | undefined) => ReferenceFieldGenerator;
    reference(name?: string, title?: string): ReferenceFieldGenerator;
    slug(name?: string, title?: string): SlugFieldGenerator;
    str: (name?: string | undefined, title?: string | undefined) => StringFieldGenerator;
    string(name?: string, title?: string): StringFieldGenerator;
    text(name?: string, title?: string): TextFieldGenerator;
    url(name?: string, title?: string): UrlFieldGenerator;
    sort: (name?: string | undefined, title?: string | undefined) => OrderingGenerator;
    ordering(name?: string, title?: string): OrderingGenerator;
    view: (name?: string | undefined, title?: string | undefined) => OrderingGenerator;
    preview(select?: Record<string, string>): PreviewGenerator;
}
