import { StandardGenerator } from './base';
import { PreviewGenerator } from './preview';
export declare type PredefinedField = Record<string, any>;
export declare type SchemaValidator = (rule: any) => any;
export declare type SchemaIcon = any;
export declare type SchemaOptions = Record<string, any>;
export declare type SchemaPreviewSelect = Record<string, string>;
export declare type SchemaPreviewComponent = any;
export declare type SchemaPreviewPrepare = (selected: Record<string, any>) => Record<string, any>;
export interface SchemaPreview {
    select: SchemaPreviewSelect;
    prepare?: SchemaPreviewPrepare;
    component?: SchemaPreviewComponent;
}
export interface SchemaField {
    type: string;
    name?: string;
    title?: string | null;
    fieldset?: string;
    description?: string;
    readOnly?: boolean;
    hidden?: boolean;
    options?: SchemaOptions;
    validation?: SchemaValidator;
    preview?: PreviewGenerator;
    fields?: StandardGenerator[] | Record<string, any>;
    of?: StandardGenerator[] | Record<string, any>;
}
export interface SchemaOrder {
    field: string;
    direction: string;
}
export interface SchemaOrdering {
    name: string;
    title?: string;
    by?: SchemaOrder[];
}
export interface SchemaFieldset {
    name: string;
    title?: string | null;
    options?: {
        collapsible?: boolean;
        collapsed?: boolean;
        columns?: number;
    };
}
export declare type SchemaArrayLayout = 'tags' | 'grid';
export declare type SchemaArrayEditModal = 'dialog' | 'fullscreen' | 'popover';
export declare type SchemaArrayList = {
    title: string;
    value: string;
};
export interface SchemaObjectFieldset {
    name: string;
    title?: string;
    options?: {
        collapsible?: boolean;
        collapsed?: boolean;
        columns?: number;
    };
}
export declare type SchemaNumberPredefined = number | {
    title: string;
    value: number;
};
export declare type SchemaStringPredefined = string | {
    title: string;
    value: string;
};
export declare type SchemaBooleanLayout = 'switch' | 'checkbox';
export declare type SchemaStringLayout = 'dropdown' | 'radio';
export declare type SchemaStringDirection = 'horizontal' | 'vertical';
export declare type SchemaReference = Record<string, any>;
declare type SchemaReferenceFilterFn = (options: {
    object: any;
    parent: any;
    parentPath: string;
}) => Promise<{
    filter: any;
    params: any;
}> | {
    filter: any;
    params: any;
};
export declare type SchemaReferenceFilter = SchemaReferenceFilterFn | string;
export declare type SchemaRefrenceFilterParams = Record<string, any>;
export interface SchemaBlockStyle {
    title: string;
    value: string;
}
export interface SchemaBlockList {
    title: string;
    value: string;
}
export interface SchemaBlockMarks {
    decorators?: {
        title: string;
        value: string;
        icon?: SchemaIcon;
    }[];
    annotations?: Array<StandardGenerator>;
}
export declare type SchemaSlugSlugify = (input: string, type: Record<string, any>) => string;
export declare type SchemaImageMetadata = 'exif' | 'location' | 'lqip' | 'palette';
export {};
